All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
PRFC1155_Opaque Class Reference

`#include <rfc1155.h>`

Inheritance diagram for PRFC1155_Opaque:

## Public Member Functions

| PRFC1155_Opaque (unsigned tag=4, TagClass tagClass=ApplicationTagClass)
| PRFC1155_Opaque (const char *v)
| PRFC1155_Opaque (const PString &v)
| PRFC1155_Opaque (const PBYTEArray &v)
PRFC1155_Opaque & | operator= (const char *v)
PRFC1155_Opaque & | operator= (const PString &v)
PRFC1155_Opaque & | operator= (const PBYTEArray &v)
PObject * | Clone () const
| Create a copy of the class on the heap. More...
Public Member Functions inherited from PASN_OctetString
| PASN_OctetString (const char *str=NULL, PINDEX size=0)
| PASN_OctetString (unsigned tag, TagClass tagClass)
| PASN_OctetString (const PASN_OctetString &other)
PASN_OctetString & | operator= (const PASN_OctetString &other)
PASN_OctetString & | operator= (const char *str)
PASN_OctetString & | operator= (const PString &str)
PASN_OctetString & | operator= (const PBYTEArray &arr)
void | SetValue (const char *str)
void | SetValue (const PString &str)
void | SetValue (const PBYTEArray &arr)
void | SetValue (const BYTE *data, PINDEX len)
const PBYTEArray & | GetValue () const
| operator const PBYTEArray & () const
| operator const BYTE * () const
PString | AsString () const
BYTE | operator[] (PINDEX i) const
BYTE & | operator[] (PINDEX i)
BYTE * | GetPointer (PINDEX sz=0)
PINDEX | GetSize () const
PBoolean | SetSize (PINDEX newSize)
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | SetConstraintBounds (ConstraintType type, int lower, unsigned upper)
virtual PString | GetTypeAsString () const
| Return a string giving the type of the object. More...
virtual PINDEX | GetDataLength () const
virtual PBoolean | Decode (PASN_Stream &)
virtual void | Encode (PASN_Stream &) const
PBoolean | DecodePER (PPER_Stream &strm)
void | EncodePER (PPER_Stream &strm) const
PBoolean | DecodeSubType (PASN_Object &) const
void | EncodeSubType (const PASN_Object &)
Public Member Functions inherited from PASN_ConstrainedObject
PBoolean | IsConstrained () const
int | GetLowerLimit () const
unsigned | GetUpperLimit () const
PBoolean | ConstrainedLengthDecode (PPER_Stream &strm, unsigned &length)
void | ConstrainedLengthEncode (PPER_Stream &strm, unsigned length) const
PBoolean | ConstraintEncode (PPER_Stream &strm, unsigned value) const
Public Member Functions inherited from PASN_Object
PINDEX | GetObjectLength () const
virtual PBoolean | IsPrimitive () const
PBoolean | IsExtendable () const
void | SetExtendable (PBoolean ext=true)
TagClass | GetTagClass () const
unsigned | GetTag () const
virtual void | SetTag (unsigned newTag, TagClass tagClass=DefaultTagClass)
void | SetConstraints (ConstraintType type, int value)
void | SetConstraints (ConstraintType, int lower, MaximumValueTag)
void | SetConstraints (ConstraintType, MinimumValueTag lower, unsigned upper)
void | SetConstraints (ConstraintType, MinimumValueTag lower, MaximumValueTag upper)
void | SetConstraints (ConstraintType type, int lower, unsigned upper)
virtual void | SetCharacterSet (ConstraintType ctype, const char *charSet)
virtual void | SetCharacterSet (ConstraintType ctype, unsigned firstChar, unsigned lastChar)
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Additional Inherited Members

Public Types inherited from PASN_Object
enum | TagClass { UniversalTagClass, ApplicationTagClass, ContextSpecificTagClass, PrivateTagClass, DefaultTagClass }

enum

UniversalTags {
InvalidUniversalTag, UniversalBoolean, UniversalInteger, UniversalBitString,
UniversalOctetString, UniversalNull, UniversalObjectId, UniversalObjectDescriptor,
UniversalExternalType, UniversalReal, UniversalEnumeration, UniversalEmbeddedPDV,
UniversalSequence = 16, UniversalSet, UniversalNumericString, UniversalPrintableString,
UniversalTeletexString, UniversalVideotexString, UniversalIA5String, UniversalUTCTime,
UniversalGeneralisedTime, UniversalGeneralizedTime = UniversalGeneralisedTime, UniversalGraphicString, UniversalVisibleString,
UniversalGeneralString, UniversalUniversalString, UniversalBMPString = 30
}

enum | ConstraintType { Unconstrained, PartiallyConstrained, FixedConstraint, ExtendableConstraint }
enum | MinimumValueTag { MinimumValue = INT_MIN }
enum | MaximumValueTag { MaximumValue = INT_MAX }
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PASN_Object
static PINDEX | GetMaximumArraySize ()
static void | SetMaximumArraySize (PINDEX sz)
static PINDEX | GetMaximumStringSize ()
static void | SetMaximumStringSize (PINDEX sz)
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PASN_ConstrainedObject
| PASN_ConstrainedObject (unsigned tag, TagClass tagClass)
Protected Member Functions inherited from PASN_Object
| PASN_Object (unsigned tag, TagClass tagClass, PBoolean extend=false)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PASN_OctetString
PBYTEArray | value
Protected Attributes inherited from PASN_ConstrainedObject
ConstraintType | constraint
int | lowerLimit
unsigned | upperLimit
Protected Attributes inherited from PASN_Object
PBoolean | extendable
| PER extension capability. More...
TagClass | tagClass
| BER tag class. More...
unsigned | tag
| ASN object tag. More...

## Constructor & Destructor Documentation

PRFC1155_Opaque::PRFC1155_Opaque | ( | unsigned | tag = `4`,
|  | TagClass | tagClass = `ApplicationTagClass`
| ) |  |

PRFC1155_Opaque::PRFC1155_Opaque | ( | const char * | v | ) |

PRFC1155_Opaque::PRFC1155_Opaque | ( | const PString & | v | ) |

PRFC1155_Opaque::PRFC1155_Opaque | ( | const PBYTEArray & | v | ) |

## Member Function Documentation

PObject* PRFC1155_Opaque::Clone | ( |  | ) | const

virtual

Create a copy of the class on the heap.

The exact semantics of the descendent class determine what is required to make a duplicate of the instance. Not all classes can even do a clone operation.

The main user of the clone function is the `PDictionary` class as it requires copies of the dictionary keys.

The default behaviour is for this function to assert.

Returns
  pointer to new copy of the class instance.

Reimplemented from PASN_OctetString.

PRFC1155_Opaque& PRFC1155_Opaque::operator= | ( | const char * | v | ) |

PRFC1155_Opaque& PRFC1155_Opaque::operator= | ( | const PString & | v | ) |

PRFC1155_Opaque& PRFC1155_Opaque::operator= | ( | const PBYTEArray & | v | ) |

The documentation for this class was generated from the following file:

- rfc1155.h